]> ruderich.org/simon Gitweb - config/dotfiles.git/blobdiff - setup.sh
setup.sh: Add and use grep_i() - in-place grep.
[config/dotfiles.git] / setup.sh
index 4c14f5f4abcff775dd02bb44bd3344846ddfb4d1..370bf5c0f7006a708ddf7fe1dce564b2d0fd54cd 100755 (executable)
--- a/setup.sh
+++ b/setup.sh
@@ -22,6 +22,7 @@ set -e
 
 . ../lib.sh
 
+
 # Helper functions.
 terminal_info() {
     infocmp "$@" 2>&1
@@ -29,8 +30,11 @@ terminal_info() {
 terminal_available() {
     terminal_info "$@" > /dev/null
 }
+grep_i() {
+    cmd_i grep "$@"
+}
 # Check if `infocmp` is available.
-if ! infocmp > /dev/null 2>&1; then
+if ! infocmp >/dev/null 2>&1; then
     echo 'Warning: `infocmp` not available! 256color checks will fail.'
     echo
 fi
@@ -64,24 +68,28 @@ perl < lesskey \
     | lesskey -
 chmod 0600 ~/.less
 
+# Custom colors for GNU ls.
+if installed dircolors; then
+    echo '# WARNING! DO NOT EDIT THIS FILE!' >shell/dircolors
+    dircolors -b shell/dircolors.in >>shell/dircolors
+fi
+
 # Find the required options to get colored ls output. GNU ls is preferred. See
 # shell/aliases.in for details. Doing this here instead of in shell/aliases
 # speeds up shell starts.
 #
 # Check if colors are available.
-ls --color > /dev/null 2>&1
-if test $? -eq 0; then
+if ls --color >/dev/null 2>&1; then
     ls_color=gnu
 else
-    ls -G > /dev/null 2>&1
-    if test $? -eq 0; then
+    if ls -G >/dev/null 2>&1; then
         ls_color=cli
     else
         ls_color=
     fi
 fi
 # Absolute path to `ls`.
-ls_path=`which ls`
+ls_path=`installed_path ls`
 # GNU ls with colors.
 if test "x$ls_color" = xgnu; then
     ls_env=
@@ -95,22 +103,35 @@ else
     ls_env=
     ls_color=
 fi
+
+# Also check if `column -t` is available.
+if echo test | column -t >/dev/null 2>&1; then
+    column=' | column -t'
+else
+    column=
+fi
+
 generate perl shell/aliases \
     -e 'while (<STDIN>) {
             s/\bLS_ENV\b/$ARGV[0]/;
             s/\bLS_PATH\b/$ARGV[1]/;
             s/\bLS_COLOR\b/$ARGV[2]/;
+            s/\bCOLUMN\b/$ARGV[3]/;
             print;
         }' \
-    "$ls_env" "$ls_path" "$ls_color"
+    "$ls_env" "$ls_path" "$ls_color" "$column"
+
+# If `tig` is not available use my simple replacement.
+if ! installed tig; then
+    echo "alias tig='git tig'" >>shell/aliases
+fi
 
 # Check if grep supports --color=auto.
 if echo test | grep --color=auto test >/dev/null 2>&1; then
     :
 else
     echo 'shell/aliases: removing grep --color=auto'
-    sed '/^alias grep=/ s/^/#/' shell/aliases > shell/aliases.tmp
-    mv shell/aliases.tmp shell/aliases
+    sed_i '/^alias grep=/ s/^/#/' shell/aliases
 fi
 
 generate cat screenrc .in
@@ -130,7 +151,7 @@ if terminal_available screen-256color; then
         # rxvt-unicode binaries (e.g. Debian's rxvt-unicode-256color), the
         # terminal_info check for manual installations which modify
         # rxvt-unicode's terminfo entry.
-        urxvt_path=`which urxvt`
+        urxvt_path=`installed_path urxvt`
         urxvt_grep=`strings "$urxvt_path" | grep '^TERM=rxvt-'`
         if test x"$urxvt_grep" = 'xTERM=rxvt-unicode-256color' \
                 || terminal_info rxvt-unicode \
@@ -145,38 +166,33 @@ if terminal_available screen-256color; then
 fi
 if test -z "$use_256colors"; then
     echo screenrc: removing 256 colors
-    sed 's/Enable 256 color/Disable 256 color/;
-         s/screen-256color/screen/' screenrc > screenrc.tmp
-    mv screenrc.tmp screenrc
+    sed_i 's/Enable 256 color/Disable 256 color/;
+           s/screen-256color/screen/' screenrc
 fi
 # Some options are only necessary when running as root. They are marked as
 # "(ROOT)".
 if test "`id -u`" -ne 0; then
     echo screenrc: removing root options
-    grep -v '(ROOT)' screenrc > screenrc.tmp
-    mv screenrc.tmp screenrc
+    grep_i -v '(ROOT)' screenrc
 fi
 # I use some features of GNU screen which are only in Git or very recent GNU
 # screen versions. Drop them on machines which have older versions. They are
 # marked as "(GIT)".
 if test ! -d "$HOME/development/shell/screen"; then
     echo screenrc: removing Git features
-    grep -v '(GIT)' screenrc > screenrc.tmp
-    mv screenrc.tmp screenrc
+    grep_i -v '(GIT)' screenrc
 fi
 # Rxvt doesn't need the attrcolor "fix". As I prefer rxvt assume I use it when
 # it's installed.
 if installed rxvt; then
     echo screenrc: removing attrcolor \"fix\"
-    sed 's/attrcolor b ".I"/#attrcolor b ".I"/' screenrc > screenrc.tmp
-    mv screenrc.tmp screenrc
+    sed_i 's/attrcolor b ".I"/#attrcolor b ".I"/' screenrc
 fi
 # Display current battery charge on computers with a battery. Necessary lines
 # are marked as "(BATTERY)".
 if test ! -d /sys/class/power_supply/BAT0; then
     echo screenrc: removing battery display
-    grep -v '(BATTERY)' screenrc > screenrc.tmp
-    mv screenrc.tmp screenrc
+    grep_i -v '(BATTERY)' screenrc
 fi
 
 if installed tmux; then
@@ -184,10 +200,10 @@ if installed tmux; then
 
     # Add mappings to switch to windows 10-29 quickly. See tmux-window.pl for
     # details.
-    perl ./tmux-window.pl 1 "`pwd`/tmux-window2.conf" > tmux-window1.conf
-    perl ./tmux-window.pl 2                           > tmux-window2.conf
+    perl ./tmux-window.pl 1 "`pwd`/tmux-window2.conf" >tmux-window1.conf
+    perl ./tmux-window.pl 2                           >tmux-window2.conf
     # Set absolute path to tmux-window1.conf in tmux.conf.
-    perl < tmux.conf > tmux.conf.tmp \
+    perl <tmux.conf >tmux.conf.tmp \
         -e 'while (<STDIN>) {
                 s/\bTMUX_WINDOW_PATH\b/$ARGV[0]/;
                 print;
@@ -198,27 +214,19 @@ if installed tmux; then
     # 256 colors not available.
     if test -z "$use_256colors"; then
         echo tmux.conf: removing 256 colors
-        sed 's/Enable 256 color/Disable 256 color/;
-             s/screen-256color/screen/' tmux.conf > tmux.conf.tmp
-        mv tmux.conf.tmp tmux.conf
+        sed_i 's/Enable 256 color/Disable 256 color/;
+               s/screen-256color/screen/' tmux.conf
     fi
     # Tmux doesn't display a warning if the shell wasn't found!
     if test ! -x '/bin/zsh'; then
         echo tmux.conf: removing /bin/zsh as shell
-        sed 's/zsh/sh/' tmux.conf > tmux.conf.tmp
-        mv tmux.conf.tmp tmux.conf
+        sed_i 's/zsh/sh/' tmux.conf
     fi
 fi
 
 # Htop overwrites the comments in its configuration file.
 generate cat htoprc .in
 
-# Copy remindrc template if ~/.reminders doesn't exist yet.
-if installed remind && test ! -e "$HOME/.reminders"; then
-    echo remind: copying template to .reminders
-    cp reminders.in "$HOME/.reminders"
-fi
-
 
 # LINK SETUP
 
@@ -255,4 +263,6 @@ if installed htop; then
     mkdir -p ~/.config/htop
     link htoprc ~/.config/htop/htoprc
 fi
-
+if test -d ~/.ssh && test -O ~/.ssh; then
+    link ssh_config ~/.ssh/config
+fi